#ifndef QUEUE_H
#define QUEUE_H

/* * * * * * * * *
 * GENERIC QUEUE *
 * * * * * * * * */

#define QEMPTYNULL(E)

// NOTE: The use of the temporary variable "t" in the push implementation is to
// work around a compiler parsing bug (CCS v4.042)
#define GENERIC_Q(NAME,TYPE,SIZE,IDXTYPE,QEMPTYFUNC) \
TYPE NAME##_q[SIZE];                                 \
IDXTYPE NAME##_head, NAME##_tail;                    \
void NAME##_init(void)                               \
{                                                    \
  NAME##_head = 0;                                   \
  NAME##_tail = 0;                                   \
  QEMPTYFUNC(TRUE);                                  \
}                                                    \
int1 NAME##_isempty(void)                            \
{                                                    \
  return NAME##_head == NAME##_tail;                 \
}                                                    \
int1 NAME##_isfull(void)                             \
{                                                    \
  IDXTYPE t;                                         \
  t = NAME##_tail + 1;                               \
  if (t >= SIZE) t = 0;                              \
  return t == NAME##_head;                           \
}                                                    \
void NAME##_push(TYPE *d)                            \
{                                                    \
  IDXTYPE t;                                         \
  t = NAME##_tail;                                   \
  memcpy(&NAME##_q[t], d, sizeof(TYPE));             \
  if (++t >= SIZE) t = 0;                            \
  NAME##_tail = t;                                   \
  if (NAME##_tail == NAME##_head)                    \
    if (++NAME##_head >= SIZE)                       \
      NAME##_head = 0;                               \
  QEMPTYFUNC(FALSE);                                 \
}                                                    \
void NAME##_pop(TYPE *d)                             \
{                                                    \
  if (NAME##_tail != NAME##_head)                    \
  {                                                  \
    memcpy(d, &NAME##_q[NAME##_head], sizeof(TYPE)); \
    if (++NAME##_head >= SIZE) NAME##_head = 0;      \
  }                                                  \
  if (NAME##_tail == NAME##_head) QEMPTYFUNC(TRUE);  \
}

#endif /* QUEUE_H */
